Index: /trunk/tests/org/expeditee/gui/FrameTest.java
===================================================================
--- /trunk/tests/org/expeditee/gui/FrameTest.java	(revision 455)
+++ /trunk/tests/org/expeditee/gui/FrameTest.java	(revision 456)
@@ -7,5 +7,5 @@
 import junit.framework.TestCase;
 
-import org.expeditee.items.Permission;
+import org.expeditee.items.UserAppliedPermission;
 
 public class FrameTest extends TestCase {
@@ -50,5 +50,5 @@
 		assertEquals(0, overlays.size());
 		
-		Overlay o = new Overlay(new Frame(), Permission.none);
+		Overlay o = new Overlay(new Frame(), UserAppliedPermission.none);
 		f.addOverlay(o);
 		assertEquals(0, overlays.size()); // getOverlays should be immutable
@@ -64,8 +64,8 @@
 		FrameGraphics.setMaxSize(new Dimension(100,100));
 		
-		Overlay o1 = new Overlay(f1, Permission.none);
-		Overlay o2 = new Overlay(f2, Permission.followLinks);
-		Overlay o3 = new Overlay(f3, Permission.copy);
-		Overlay o4 = new Overlay(f4, Permission.createFrames);
+		Overlay o1 = new Overlay(f1, UserAppliedPermission.none);
+		Overlay o2 = new Overlay(f2, UserAppliedPermission.followLinks);
+		Overlay o3 = new Overlay(f3, UserAppliedPermission.copy);
+		Overlay o4 = new Overlay(f4, UserAppliedPermission.createFrames);
 		
 		root.addOverlay(o1);
@@ -86,10 +86,10 @@
 		
 		overlays.clear();
-		overlays.add(new Overlay(new Frame(), Permission.none));
-		overlays.add(new Overlay(new Frame(), Permission.followLinks));
-		overlays.add(new Overlay(new Frame(), Permission.copy));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.none));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.followLinks));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.copy));
 		overlays.add(o4);
-		overlays.add(new Overlay(new Frame(), Permission.createFrames));
-		overlays.add(new Overlay(new Frame(), Permission.full));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.createFrames));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.full));
 		String framesetname = "X";
 		for (Overlay o : overlays) {
@@ -118,9 +118,9 @@
 		
 		Collection<Overlay> overlays = new LinkedList<Overlay>();
-		overlays.add(new Overlay(new Frame(), Permission.none));
-		overlays.add(new Overlay(new Frame(), Permission.followLinks));
-		overlays.add(new Overlay(new Frame(), Permission.copy));
-		overlays.add(new Overlay(new Frame(), Permission.createFrames));
-		overlays.add(new Overlay(new Frame(), Permission.full));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.none));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.followLinks));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.copy));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.createFrames));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.full));
 		String framesetname = "X";
 		for (Overlay o : overlays) {
@@ -145,10 +145,10 @@
 		
 		Collection<Overlay> overlays = new LinkedList<Overlay>();
-		Overlay toRemove = new Overlay(new Frame(), Permission.followLinks);
-		overlays.add(new Overlay(new Frame(), Permission.none));
+		Overlay toRemove = new Overlay(new Frame(), UserAppliedPermission.followLinks);
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.none));
 		overlays.add(toRemove);
-		overlays.add(new Overlay(new Frame(), Permission.copy));
-		overlays.add(new Overlay(new Frame(), Permission.createFrames));
-		overlays.add(new Overlay(new Frame(), Permission.full));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.copy));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.createFrames));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.full));
 		String framesetname = "X";
 		for (Overlay o : overlays) {
@@ -174,10 +174,10 @@
 		FrameGraphics.setMaxSize(new Dimension(100,100));
 		
-		Overlay o0 = new Overlay(f1, Permission.none);
-		Overlay o1 = new Overlay(f1, Permission.full);
-		Overlay o2 = new Overlay(f2, Permission.followLinks);
-		Overlay o3 = new Overlay(f3, Permission.copy);
-		Overlay o4 = new Overlay(f4, Permission.createFrames);
-		Overlay o5 = new Overlay(f5, Permission.copy);
+		Overlay o0 = new Overlay(f1, UserAppliedPermission.none);
+		Overlay o1 = new Overlay(f1, UserAppliedPermission.full);
+		Overlay o2 = new Overlay(f2, UserAppliedPermission.followLinks);
+		Overlay o3 = new Overlay(f3, UserAppliedPermission.copy);
+		Overlay o4 = new Overlay(f4, UserAppliedPermission.createFrames);
+		Overlay o5 = new Overlay(f5, UserAppliedPermission.copy);
 		
 		f1.addOverlay(o2);
@@ -214,9 +214,9 @@
 		
 		overlays.clear();
-		overlays.add(new Overlay(new Frame(), Permission.none));
-		overlays.add(new Overlay(new Frame(), Permission.followLinks));
-		overlays.add(new Overlay(new Frame(), Permission.copy));
-		overlays.add(new Overlay(new Frame(), Permission.createFrames));
-		overlays.add(new Overlay(new Frame(), Permission.full));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.none));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.followLinks));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.copy));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.createFrames));
+		overlays.add(new Overlay(new Frame(), UserAppliedPermission.full));
 		String framesetname = "X";
 		for (Overlay o : overlays) {